<?php
require_once "simpleclass.php";

class SimpleParser {
   var $parser;
   var $error_code;
   var $error_string;
   var $current_line;
   var $current_column;
   var $data;
   var $datas = array();
   
   function parse($data) {
       $this->parser = xml_parser_create('UTF-8'); //
       xml_set_object($this->parser, $this);
       xml_parser_set_option($this->parser, XML_OPTION_SKIP_WHITE, 1);
       xml_parser_set_option($this->parser, XML_OPTION_CASE_FOLDING, 0);
       xml_set_element_handler($this->parser, 'tag_open', 'tag_close');
       xml_set_character_data_handler($this->parser, 'cdata');
              
       if (!xml_parse($this->parser, $data)) {
           //$this->data = array;
           $this->data = new SimpleClass;
           $this->error_code = xml_get_error_code($this->parser);
           $this->error_string = xml_error_string($this->error_code);
           $this->current_line = xml_get_current_line_number($this->parser);
           $this->current_column = xml_get_current_column_number($this->parser);
       } else {
           $this->data = $this->datas[0];
       } 
       
       xml_parser_free($this->parser);
       
       return $this->data;
   }

   function tag_open($parser, $tag, $attribs) {
       $node = new SimpleClass();
       $node->setArray($attribs);
       $node->setProp("_TAGNAME", $tag);
       $this->datas[] = $node;
   }

   function cdata($parser, $cdata) {
       $this->datas[count($this->datas)-1]->setProp("_CDATA", $cdata);
   }

   function tag_close($parser, $tag)  {
   		if (count($this->datas) > 1) {
	   		$child = array_pop($this->datas);
	   		   		
	   		if (count($this->datas) > 0) {
	   			$parent = &$this->datas[count($this->datas)-1];
	   			$tag = $child->_TAGNAME;
		   		
		   		if ($parent->hasProp($tag)) {
		   			if (is_array($parent->$tag)) {
		   				//Add to children array
		   				$array = &$parent->$tag;
		   				$array[] = $child;
		   			} else {
		   				//Convert node to an array
			   			$children = array();
			   			$children[] = $parent->$tag;
			   			$children[] = $child;
			   			$parent->$tag = $children;
			   		}
		   		} else {
		   			$parent->setProp($tag, $child);
		   		}
		   	}
		  }
   }
}
?>